# frozen_string_literal: true

module Lexicon
  module Cli
    module Extension
      class ExtensionBase
        # @param [Corindon::DependencyInjection::Container] container
        def boot(container) end

        def commands; end

        private

          # @param [Corindon::DependencyInjection::Container] container,
          # @param [Hash<String=>Object>] parameters
          def register_parameters(container, parameters = {})
            parameters.each do |k, v|
              key = if k.is_a?(Corindon::DependencyInjection::Token::ParameterToken)
                      k.key
                    else
                      k
                    end

              container.set_parameter(key, v)
            end
          end

          # @param [Corindon::DependencyInjection::Container] container
          # @param [Array<Class>] services
          def register_all(*services, container:)
            services.each { |s| container.add_definition(s) }
          end
      end
    end
  end
end
